#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <vector>
#include <algorithm>

#pragma warning (disable:4996)

using namespace std;

#define MAXF 51
#define MAXP 101

#define DECLARE_TIMER(x) LARGE_INTEGER timer##x = {0LL}, x##_s, x##_e;
#define START_TIMER(x)   { QueryPerformanceCounter(&(x##_s));}
#define STOP_TIMER(x)    { QueryPerformanceCounter(&(x##_e)); timer##x.QuadPart = x##_e.QuadPart - x##_s.QuadPart; }
#define GET_TIMER(x)    (int)(timer##x.QuadPart * 1000 / liFrequency.QuadPart)

DECLARE_TIMER(PARA)

typedef struct _ANIMAL
{
    int width;
    int height;
    vector< pair< int, int > > body;
} ANIMAL;

LARGE_INTEGER liFrequency;
int SavedF[MAXF][MAXF];
int MaxSavedF[MAXF][MAXF];
int F[MAXF][MAXF];
int N, M, P;
ANIMAL A[MAXP];
pair< int, int > D[MAXP];
pair< int, int > L[MAXP];
int Used[MAXP];
vector< pair< int, int >  > SavedO;
int Sol[MAXP][3];
int MaxSol[MAXP][3];
int MMM[MAXP], SMMM[MAXP];

bool myfunction( pair<int,int> &lhs, pair<int,int> &rhs) {

    double z;

    if ( lhs.second > rhs.second ) {

        z = (double)rhs.second * ( (double)100/(double)(lhs.second) );

        if ( z < 90 ) {
            return true;
        }

    } else {

        z = (double)lhs.second * ( (double)100/(double)(rhs.second) );

        if ( z < 90 ) {
            return false;
        }
    }

    return D[lhs.first].first < D[rhs.first].first;
}


int land_animal( int animal, int x, int y ) {

    int i, sum = 0;

    for ( i = 0; i < (int)A[animal].body.size(); i++ ) {

        L[ animal ] = make_pair(x, y);
        sum += F[ x + A[animal].body[i].first ][ y + A[animal].body[i].second ];
        F[ x + A[animal].body[i].first ][ y + A[animal].body[i].second ] /= D[animal].first;
    }

    return sum;
}


int get_safety( int animal, int x, int y ) {

    int i, z, safety = 0;

    for ( i = 0; i < (int)A[animal].body.size(); i++ ) {

        z = F[ x + A[animal].body[i].first ][ y + A[animal].body[i].second ];

        if ( z < D[animal].second ) {

            return -1;
        }

        safety += z;

    }

    return safety;
}


pair< int, int > get_idx_max( int animal ) {

    int i, j, s, mx, imx, jmx;

    mx = imx = jmx = -1;

    for ( i = 0; i < N - A[animal].height + 1; i++) {

        for ( j = 0; j < M - A[animal].width + 1; j++ ) {

            s = get_safety( animal, i, j );

            if ( s > mx ) {

                mx = s;
                imx = i;
                jmx = j;
            }
        }
    }

    return make_pair( imx, jmx );
}


int main( int argc, char *argv[] ) {

    FILE *fin = fopen("parash.in", "r");
    FILE *fout = fopen("parash.out", "w+");
    int i, j, p, r, c, k, t, square_full, square_all, z;
    int from, start, len, animal_count, max_animal_count, saved_animal_count, safety, max_safety, saved_safety;
    pair<int, int> pos;
    int order[] = {0,1,2,3,4,5,6,7,8,9};
    int prev_order[] = {0,1,2,3,4,5,6,7,8,9};
    int idx[] = {0,1,2,3,4,5,6,7,8,9};
    char line[12];

    QueryPerformanceFrequency(&liFrequency);

    START_TIMER(PARA)

    fscanf(fin, "%d %d %d", &N, &M, &P);

    for ( i = 0; i < N; i++ ) {
        for ( j = 0; j < M; j++ ) {

            fscanf(fin, "%d", &SavedF[i][j]);
        }
    }

    for ( p = 0; p < P; p++ ) {

        square_full = 0;
        square_all = 0;

        fscanf(fin, "%d %d %d %d\n", &r, &c, &k, &t);

        A[p].height = r;
        A[p].width = c;

        D[p] = make_pair( k, t );

        for ( i = 0; i < r; i++ ) {

            fgets(line, c+2, fin);

            for ( j = 0; j < c; j++ ) {

                if (line[j]-'0') {

                    A[p].body.push_back( make_pair( i, j ) );
                    square_full++;
                }

                square_all++;
            }
        }

        if ( square_all > 50 && (double)((double)square_full/(double)(square_all)) < 0.5 )
            square_all = (int)((double)square_all * 0.90);

        SavedO.push_back( make_pair( p, square_all ) );
    }

    sort( SavedO.begin(), SavedO.end(), myfunction );

//#################################################################################################

    max_animal_count = 0;
    saved_animal_count = 0;
    max_safety = 0;
    saved_safety = 0;
    from = 0;

    if ( M*N <= 50 ) {
        len = 9;
    } else if (M*N <= 100) {
        len = 8;
    } else if (M*N <= 625) {
        len = 7;
    } else if (M*N <= 1500) {
        len = 6;
    } else {
        len = 5;
    }

retry:

    max_animal_count = 0;
    saved_animal_count = 0;
    max_safety = 0;
    saved_safety = 0;
    from = 0;

    while (1) {

        saved_animal_count = 0;
        saved_safety = 0;
        from = 0;

        while (1) {

            for (i = from, j = 0; i < P && j < len; i++) {

                if (!Used[SavedO[i].first]) {
                    order[j] = j;
                    idx[j] = SavedO[i].first;
                    j++;
                }
            }

            len = j;
            if (len == 0) {

                break;
            }

            for (i = 0; i < len; i++) {
                prev_order[i] = 0xFF;
            }

            do {

                animal_count = saved_animal_count;
                safety = saved_safety;

                for (i = 0; i < N; i++) {

                    memcpy(F[i], SavedF[i], M * sizeof(int));
                }

                start = 0;
                i = 0;

                while (order[i] == prev_order[i]) {

                     z = get_safety( idx[order[i]],  L[idx[order[i]]].first, L[idx[order[i]]].second );
                     if (z == -1) {
                         break;
                     }

                     safety += land_animal( idx[order[i]], L[idx[order[i]]].first, L[idx[order[i]]].second );
                     Sol[animal_count][0] = idx[order[i]]+1;
                     Sol[animal_count][1] = L[idx[order[i]]].first+1;
                     Sol[animal_count][2] = L[idx[order[i]]].second+1;
                     start++;
                     animal_count++;
                     i++;
                }

                for (i = start; i < len; i++) {

                    if ( !Used[ idx[order[i]] ] ) {

                        pos = get_idx_max( idx[order[i]] );
                        if ( (pos.first != -1) && (pos.second != -1) ) {

                            safety += land_animal( idx[order[i]], pos.first, pos.second );
                            Sol[animal_count][0] = idx[order[i]]+1;
                            Sol[animal_count][1] = pos.first+1;
                            Sol[animal_count][2] = pos.second+1;
                            animal_count++;
                        }
                    }
                }

                STOP_TIMER(PARA)
                if (GET_TIMER(PARA) > 1800) goto print_sol;

                for (i = from+len; i < P; i++) {

                    if ( !Used[ SavedO[ i ].first ] ) {
                        pos = get_idx_max( SavedO[ i ].first );
                        if ( (pos.first != -1) && (pos.second != -1) ) {

                            safety += land_animal( SavedO[ i ].first, pos.first, pos.second );
                            Sol[animal_count][0] = SavedO[ i ].first+1;
                            Sol[animal_count][1] = pos.first+1;
                            Sol[animal_count][2] = pos.second+1;
                            animal_count++;
                        }
                    }
                }

                if (safety > max_safety) {

                    max_animal_count = animal_count;
                    memcpy(MaxSol, Sol, sizeof(Sol));
                    max_safety = safety;
                }

                memcpy(prev_order, order, sizeof(order));

                STOP_TIMER(PARA)
                if (GET_TIMER(PARA) > 1800) goto print_sol;

            } while ( next_permutation( order, order + len ) );

            break;

            from += len;

            len = 5;
        }

        break;
    }

//#################################################################################################

STOP_TIMER(PARA)
if (GET_TIMER(PARA) < 500) { len += 1; goto retry; }

print_sol:

    //printf("%d\n", max_safety);
    //fprintf(fout, "%d\n", max_safety);

    fprintf(fout, "%d\n", max_animal_count);

    if (max_animal_count) {

        for ( i = 0; i < max_animal_count; i++ ) {

            fprintf(fout, "%d %d %d\n", MaxSol[i][0], MaxSol[i][1], MaxSol[i][2]);
        }
    }

    return 0;
}